let rec size k = match k with
  | 0 -> []
  | _ -> (Scanf.scanf "%d " (fun x -> x))::(size (k-1));;
let rec sort l1 l2 (a11,a12,a13,a22,a23,a33) k = match l1,l2 with
  | [],_ -> (a11,a12,a13,a22,a23,a33)
  | _,[] -> (a11,a12,a13,a22,a23,a33)
  | h1::t1,h2::t2 -> match (h1 * h2) with
    | 1 -> sort t1 t2 (k::a11,a12,a13,a22,a23,a33) (k-1)
    | 2 -> sort t1 t2 (a11,k::a12,a13,a22,a23,a33) (k-1)
    | 3 -> sort t1 t2 (a11,a12,k::a13,a22,a23,a33) (k-1)
    | 4 -> sort t1 t2 (a11,a12,a13,k::a22,a23,a33) (k-1)
    | 6 -> sort t1 t2 (a11,a12,a13,a22,k::a23,a33) (k-1)
    | _ -> sort t1 t2 (a11,a12,a13,a22,a23,k::a33) (k-1);;
let rec fillWith (r1,r2,r3) (a11,a12,a13,a22,a23,a33) = match a11,a12,a13,a22,a23,a33 with
  | _,_,_,_,_,h::t -> fillWith (h::h::h::r1,h::h::h::r2,h::h::h::r3) (a11,a12,a13,a22,a23,t)
  | _,_,_,_,h::t,_ -> fillWith (h::h::r1,h::h::r2,h::h::r3) (a11,a12,a13,a22,t,a33)
  | _,h1::t1,_,h2::t2,_,_ -> fillWith (h1::h1::r1,h2::h2::r2,h2::h2::r3) (a11,t1,a13,t2,a23,a33)
  | _,_,h1::h2::t1,h3::h4::h5::t2,_,_ -> fillWith (h1::h1::h1::h2::h2::h2::r1,h3::h3::h4::h4::h5::h5::r2,h3::h3::h4::h4::h5::h5::r3) (a11,a12,t1,t2,a23,a33)
  | h1::t1,_,h2::t2,h3::h4::t3,_,_ -> fillWith (h1::h2::h2::h2::r1,h3::h3::h4::h4::r2,h3::h3::h4::h4::r3) (t1,a12,t2,t3,a23,a33)
  | h1::h2::t1,_,_,h3::t2,_,_ -> fillWith (h1::h2::r1,h3::h3::r2,h3::h3::r3) (t1,a12,a13,t2,a23,a33)
  | _,_,h::t,_,_,_ -> fillWith (h::r1,h::r2,h::r3) (a11,a12,t,a22,a23,a33)
  | h1::h2::h3::t,_,_,_,_,_ -> fillWith (h1::r1,h2::r2,h3::r3) (t,a12,a13,a22,a23,a33)
  | _,h1::h2::h3::t,_,_,_,_ -> fillWith (h1::h1::r1,h2::h2::r2,h3::h3::r3) (a11,t,a13,a22,a23,a33)
  | h1::t1,h2::t2,_,_,_,_ -> fillWith (h1::r1,h2::r2,h2::r3) (t1,t2,a13,a22,a23,a33)
  | _,_,_,_,_,_ -> (r1,r2,r3);;
let rec print l = match l with
  | h::[] -> Printf.printf "%d\n" h
  | h::t -> Printf.printf "%d " h; print t
  | _ -> ();;

let k,n = Scanf.scanf "%d %d\n" (fun x y -> (x,y));;
let a = size k;;
Scanf.scanf "\n";;
let b = size k;;
let c = sort a b ([],[],[],[],[],[]) k;;
let (r1,r2,r3) = fillWith ([],[],[]) c;;
print r1;;
print r2;;
print r3;;
